SystemOrganization addCategory: #SoftwareEngineeringProject!

WAComponent subclass: #LoginView
	instanceVariableNames: 'email password system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!LoginView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 18:04'!
initialize
	super initialize.
	system := System default.! !

!LoginView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 18:05'!
renderContentOn: html
	html header: 'Login'.
	html form: [
        html text: 'Email: '.
        html textInput
            callback: [ :value | email := value ];
            value: ''.
        html break.
        html text: 'Password: '.
        html textInput
            callback: [ :value | password := value ];
            value: ''.
        html break.
        html submitButton
            callback:  [system email: email password: password. self answer];
            value: 'Save']! !

WAComponent subclass: #SignUpView
	instanceVariableNames: 'system isAdmin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!SignUpView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:11'!
initialize
	super initialize.
	system := System default.
	isAdmin := false! !

!SignUpView methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 17:12'!
isAdmin
	^ isAdmin! !

!SignUpView methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 17:12'!
isAdmin: anObject
	isAdmin := anObject! !

!SignUpView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:15'!
renderContentOn: html
	isAdmin ifTrue: [self renderSignUpAdmin: system admin on: html]
		ifFalse: [self renderSignUpOn: html]! !

!SignUpView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:13'!
renderSignUpAdmin: admin on: html
	|validationNeeded|
	html form: [
        html text: 'Email: '.
        html textInput
            callback: [ :value | admin email: value ];
            value: ''.
        html break.
        html text: 'Password: '.
        html textInput
            callback: [ :value | admin password: value ];
            value: ''.
        html break.
	html text: 'email verification'.
	html checkbox
		value: true;
		callback: [ :value | admin validationNeeded: value].
	html break.
        html submitButton
            callback: [ system registerUser: admin ];
            value: 'Save']! !

!SignUpView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:44'!
renderSignUpOn: html
	|user|
	user := User new.
	html header: 'Sign Up'.
	html form: [
        html text: 'Email: '.
        html textInput
            callback: [ :value | user email: value ];
            value: ''.
        html break.
        html text: 'Password: '.
        html textInput
            callback: [ :value | user password: value ];
            value: ''.
        html break.
        html submitButton
            callback:  [system registerUser: user. self answer];
            value: 'Save']! !

WAComponent subclass: #SystemView
	instanceVariableNames: 'system signUpForm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!SystemView class methodsFor: 'as yet unclassified' stamp: 'Dimitri 10/7/2011 09:34'!
canBeRoot
	^true! !

!SystemView class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 22:38'!
initialize 
	| application |
	application := WAAdmin register: self asApplicationAt: 'RPSS'.
	application preferenceAt: #sessionClass put: UserSession ! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:41'!
children
	^ Array with: signUpForm! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 18:14'!
initialize
	super initialize.
	system := System default.
	system view: self.
	signUpForm := SignUpView new! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/3/2011 19:59'!
login
	self call: LoginView new! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 18:30'!
renderContentOn: html

	system isInitialized ifFalse: [signUpForm isAdmin: true. html render: signUpForm]
		ifTrue: [
			self session isLoggedIn ifFalse: [self renderHomePageOn: html]
				ifTrue: [html text: self session user email. html text: ' is logged in']
		].
	self renderUserListOn: html! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 15:05'!
renderHomePageOn: html
	html anchor 
		callback: [self login];
		with: 'login '.
	html anchor 
		callback: [self signUp];
		with: 'signUp '.! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 15:06'!
renderUserListOn: html
	html unorderedList: [
        system users do: [ :user |
            html listItem: user email ] ]! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/3/2011 20:06'!
signUp
	self call: SignUpView new! !

!SystemView methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:18'!
signUpAdmin
	self call: (SignUpView new isAdmin: true; yourself)! !

!SystemView methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:27'!
system
	^ system! !

!SystemView methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:27'!
system: anObject
	system := anObject! !

WASession subclass: #UserSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!UserSession methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 22:32'!
isLoggedIn
	^ user isNil not! !

!UserSession methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 22:31'!
logout
	user := nil! !

!UserSession methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 22:32'!
user
	^ user! !

!UserSession methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 18:28'!
user: aUser
	user := aUser! !

Object subclass: #System
	instanceVariableNames: 'users admin view'
	classVariableNames: 'defaultInstance'
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!System class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 16:59'!
default
	^ defaultInstance ifNil: [defaultInstance := System new]! !

!System class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 16:59'!
reset
	defaultInstance := nil! !

!System methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:26'!
admin
	^ admin! !

!System methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:26'!
admin: anObject
	admin := anObject! !

!System methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 18:14'!
email: email password: password
	|user|
	user := self users select: 
		[:thisUser | (thisUser email = email) &  (thisUser password = password) ].
	
	user ifNotNil: [
			user first isValid ifTrue: [self view session user: user first]
		]! !

!System methodsFor: 'initialize' stamp: 'RobinDevooght 10/7/2011 16:54'!
initialize
	admin := Admin new.
	users := OrderedCollection new.! !

!System methodsFor: 'initialize' stamp: 'RobinDevooght 10/7/2011 16:54'!
isInitialized
	^ admin isValid! !

!System methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 16:55'!
registerUser: aUser
	users add: aUser.
	aUser signUpProcedure! !

!System methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:26'!
users
	^ users! !

!System methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 18:13'!
users: anObject
	users := anObject! !

!System methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 18:13'!
view
	^ view! !

!System methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 18:13'!
view: anObject
	view := anObject! !

Object subclass: #User
	instanceVariableNames: 'email password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

User subclass: #Admin
	instanceVariableNames: 'validationNeeded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoftwareEngineeringProject'!

!Admin methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 16:53'!
signUpProcedure
	validationNeeded 
		ifTrue: [self signUpVerificationMail] 
		ifFalse: 	[self validate]! !

!Admin methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 16:53'!
validationNeeded
	^ validationNeeded! !

!Admin methodsFor: 'accessing' stamp: 'RobinDevooght 10/7/2011 16:53'!
validationNeeded: anObject
	validationNeeded := anObject! !

!User class methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 17:52'!
email: email password: password
	^ User users select: 
		[:thisUser | (thisUser email = email) &  (thisUser password = password) ]
! !

!User methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:20'!
email
	^ email! !

!User methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:20'!
email: anObject
	email := anObject! !

!User methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 12:58'!
initialize
	super initialize.
	validated := false! !

!User methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 12:57'!
isValid 
	^ validated! !

!User methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:20'!
password
	^ password! !

!User methodsFor: 'accessing' stamp: 'Dimitri 10/7/2011 09:20'!
password: anObject
	password := anObject! !

!User methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/7/2011 16:53'!
signUpProcedure
	self signUpVerificationMail! !

!User methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 19:07'!
signUpVerificationMail 
	self validate! !

!User methodsFor: 'as yet unclassified' stamp: 'RobinDevooght 10/2/2011 12:56'!
validate
	validated := true! !
SystemView initialize!
